get.d.y <- function(xy,times,path.list){

#
#  Mevin Hooten (20090502)
#  Devin Johnson
#
#  Notes:  Only works with UTM coordinates currently.
#
#
#############
#  Updates  #
#############
#
#  20090419:  Fixed NA problem in yit.  
#  20090524:  Worked on directions for moves.
#  20090526:  Worked on directions for moves.
#  20090527:  Modified code to incorporate Devin's revisions (not UTM specific).
#
#

get.dir <- function(x,y,unit="degrees"){
  x.new=outer(x,x,"-")
  y.new=outer(y,y,"-")
  angles=atan2(x.new,y.new)
  diag(angles)=NA
  if(unit=="degrees"){angles=180*angles/pi}
  if(unit=="radians"){angles}
  angles
}

n.ani = length(path.list)
T = length(times)
yd.list = vector("list", n.ani)
min.x = min(diff(sort(xy[, 1]))[diff(sort(xy[, 1])) > 0])
min.y = min(diff(sort(xy[, 2]))[diff(sort(xy[, 2])) > 0])
x.uniq = sort(unique(xy[, 1]))
y.uniq = sort(unique(xy[, 2]))
ny = length(y.uniq)
nx = length(x.uniq)
x.breaks = c(x.uniq - min.x/2, max(x.uniq) + min.x/2)
y.breaks = c(y.uniq - min.y/2, max(y.uniq) + min.y/2)
for (i in 1:n.ani) {
  cat(i, "\n")
  tmp.cell.numb = rep(0, T)
  tmp.x.g = findInterval(path.list[[i]][, 1], x.breaks)
  tmp.y.g = findInterval(path.list[[i]][, 2], y.breaks)
  tmp.x.y.g = (tmp.x.g-1)*ny + ny-tmp.y.g+1
  tmp.rle = rle(tmp.x.y.g)
  tmp.d = tmp.rle$lengths
  tmp.locs = tmp.rle$values
  n.moves = length(tmp.locs)

#  tmp.yit <- cbind(ifelse(diff(tmp.locs)== -ny, 1, 0),
#    ifelse(diff(tmp.locs)== -1, 1, 0),
#    ifelse(diff(tmp.locs)== 1, 1, 0),
#    ifelse(diff(tmp.locs)== ny, 1, 0))
#  tmp.yit <- rbind(tmp.yit,c(0,0,0,0))

  tmp.yit=matrix(0,n.moves,4)
  for(j in 1:(n.moves-1)){
    tmp.dir=get.dir(xy[tmp.locs[j:(j+1)],1],xy[tmp.locs[j:(j+1)],2])[2,1]  
    if((tmp.dir <= -45) & (tmp.dir > -135)){tmp.yit[j,1]=1}	# West
    if((tmp.dir > -45) & (tmp.dir <= 45)){tmp.yit[j,2]=1}	# North 
    if(!((tmp.dir > -135) & (tmp.dir <= 135))){tmp.yit[j,3]=1}	# South 
    if((tmp.dir > 45) & (tmp.dir < 135)){tmp.yit[j,4]=1}	# East 
  }

  tmp.yit[apply(tmp.yit == 0, 1, all), ] = NA
  yd.list[[i]] = cbind(tmp.locs, tmp.d, tmp.yit)
}
cat("\n")

yd.list

}


########################
########################  OLD STUFF BELOW
########################
if(FALSE){

n.ani=length(path.list)
T=length(times)
yd.list=vector("list",n.ani)
#lc[,3]=round(lc[,3],1)
#lc[,4]=round(lc[,4],1)
min.x=min(diff(sort(lc[,3]))[diff(sort(lc[,3]))>0])
min.y=min(diff(sort(lc[,4]))[diff(sort(lc[,4]))>0])
x.uniq=sort(unique(lc[,3]))
y.uniq=sort(unique(lc[,4]))
x.breaks=c(x.uniq-min.x/2,max(x.uniq)+min.x/2)
y.breaks=c(y.uniq-min.y/2,max(y.uniq)+min.y/2)

lc.x.y=round(lc[,3]*10)+round(lc[,4])/10000000

for(i in 1:n.ani){
  cat(i,"\n")
  tmp.cell.numb=rep(0,T)
  tmp.x.g=x.uniq[findInterval(path.list[[i]][,1],x.breaks)]  
  tmp.y.g=y.uniq[findInterval(path.list[[i]][,2],y.breaks)]  
  tmp.x.y.g=round(tmp.x.g*10)+round(tmp.y.g)/10000000
  tmp.cell.numb=lc[match(tmp.x.y.g,lc.x.y),1]


  tmp.rle=rle(tmp.cell.numb)
  tmp.d=tmp.rle$lengths
  tmp.locs=tmp.rle$values
  n.moves=length(tmp.locs)
  tmp.yit=matrix(0,n.moves,4)

  for(j in 1:(n.moves-1)){
    tmp.dir=get.dir(lc[tmp.locs[j:(j+1)],3],lc[tmp.locs[j:(j+1)],4])[2,1]  
    if((tmp.dir <= -45) & (tmp.dir > -135)){tmp.yit[j,1]=1}	# West
    if((tmp.dir > -45) & (tmp.dir <= 45)){tmp.yit[j,2]=1}	# North 
    if(!((tmp.dir > -135) & (tmp.dir <= 135))){tmp.yit[j,3]=1}	# South 
    if((tmp.dir > 45) & (tmp.dir < 135)){tmp.yit[j,4]=1}	# East 
  }

  tmp.yit[apply(tmp.yit==0,1,all),]=NA
  yd.list[[i]]=cbind(tmp.locs,tmp.d,tmp.yit)

}
cat("\n")
yd.list

}


