make.cov.plot <- function(paths=FALSE){

#
#   Mevin Hooten (20090702)
#
#   Last Updated:
#
#

####
####  Subroutines and Packages 
####

require(splancs)

####
####  Get Convex Hull 
####

dims=c(mx.sm,my.sm)
x=x.sm
y=y.sm

eps = max(min(diff(x)), min(diff(y)))
path = rbind(gps1.fall.path.list[[1]],gps1.spring.path.list[[1]])
buff.pts <- do.call('rbind',list(cbind(path[,1]+eps,path[,2]+eps),
                         cbind(path[,1]+eps,path[,2]-eps),
                         cbind(path[,1]-eps,path[,2]+eps),
                         cbind(path[,1]-eps,path[,2]-eps)))
path.hull = chull(buff.pts[, 1], buff.pts[, 2])
path.hull = c(path.hull, path.hull[1])
hullpoly = as.points(buff.pts[path.hull, 1], buff.pts[path.hull, 2])
x.lim = range(buff.pts[path.hull, 1])
y.lim = range(buff.pts[path.hull, 2])

grd.locs=expand.grid(rev(y),x)[,2:1]
in.idx=inout(as.points(grd.locs[,1],grd.locs[,2]),hullpoly,bound=TRUE)
in.mat.idx=matrix(in.idx,dims[2],dims[1])

####
####  Make Plots 
####

x11(width=7,height=12)
layout(matrix(1:6,3,2))
for(i in 1:6){
  tmp.X=gps1.fall.out$X[,i]
  tmp.X[!in.idx]=NA
  image(t(matrix(tmp.X,my.sm,mx.sm))[,my.sm:1],x=x.sm,y=y.sm,asp=TRUE,xlab="",ylab="",col=gray.colors.rev(100),main=i,cex.main=2,axes=FALSE,xlim=range(hullpoly[,1]),ylim=range(hullpoly[,2]))
  if(paths){
    lines(gps1.spring.path.list[[1]],type="l",col=4,lwd=3)
    lines(gps1.fall.path.list[[1]],type="l",col=2,lwd=3)
  }
  lines(hullpoly,lwd=2)
#  box()
}

}
