make.data.plot <- function(){

#
#   Mevin Hooten (20090612)
#
#   Last Updated:
#
#   20090613: added plots for fall / summer data
#


x11(width=4,height=8)
plot(gps1.df[,3:4],type="p",cex=.25,asp=TRUE,ylab="",xlab="")
box()

x11(width=5.5,height=8)
n.ani=length(gps1.fall.path.list)
j.cols=jet.colors(n.ani)
plot(gps1.fall.path.list[[1]],type="n",ylab="",xlab="",xlim=c(645500,649000),ylim=c(4267500,4271500))
for(i in 1:n.ani){
  lines(gps1.fall.path.list[[i]],type="l",col=j.cols[i])
}
points(gps1.fall.df[,2:3],cex=1,pch=21,bg=1)
box()

x11(width=5.5,height=8)
tmp.mat=lc.2.mat[,2]
tmp.uniq=sort(unique(tmp.mat))
ii=1
for(j in tmp.uniq){
  tmp.mat[tmp.mat==j]=ii
  ii=ii+1
}

image(t(matrix(tmp.mat,my,mx))[,my:1],x=x.locs,y=y.locs,asp=TRUE,xlim=c(645500,649000),ylim=c(4267500,4271500),xlab="",ylab="",col=gray.colors.rev(5))
lines(gps1.fall.path.list[[1]],type="l",col=2,lwd=3)
points(gps1.fall.df[,2:3],cex=1,pch=21,bg=4,col=4)
box()

x11(width=14,height=9)
layout(matrix(1:8,2,4))
for(i in 1:8){
  image(t(matrix(gps1.fall.out$X[,i],my.sm,mx.sm))[,my.sm:1],x=x.sm,y=y.sm,asp=TRUE,xlab="",ylab="",col=jet.colors(100),main=i,cex.main=2)
  lines(gps1.fall.path.list[[1]],type="l",col="white",lwd=3)
}

if(FALSE){

x11()
min.y=min(diff(y.locs))
min.x=min(diff(x.locs))
image(t(matrix(tmp.mat,my,mx))[,my:1],x=x.locs,y=y.locs,xlim=c(646750,647200),ylim=c(4270800,4271000),xlab="",ylab="",col=gray.colors.rev(5))
lines(gps1.fall.path.list[[1]],type="l",col=2,lwd=3)
points(gps1.fall.df[,2:3],cex=1,pch=21,bg=4,col=4)
abline(v=x.locs-min.x/2)
abline(h=y.locs-min.y/2)
box()

x11(width=8,height=4)
layout(matrix(1:2,1,2))
plot(gps1.fall.path.list[[1]],type="n",ylab="",xlab="",main="GPS Data")
points(gps1.fall.df[,-1],pch=21,cex=.5,col=4,bg=4,ylab="",xlab="")
plot(gps1.fall.path.list[[1]],type="n",ylab="",xlab="",main="Posterior Predictive Path")
for(i in 1:n.ani){
  lines(gps1.fall.path.list[[i]],type="l",col=j.cols[i])
}

x11(width=8,height=4)
layout(matrix(1:2,1,2))
plot(gps1.summer.path.list[[1]],type="n",ylab="",xlab="",main="GPS Data")
points(gps1.summer.df[,-1],pch=21,cex=.5,col=4,bg=4,ylab="",xlab="")
plot(gps1.summer.path.list[[1]],type="n",ylab="",xlab="",main="Posterior Predictive Path")
for(i in 1:n.ani){
  lines(gps1.summer.path.list[[i]],type="l",col=j.cols[i])
}

}


}
