make.gps1cells.plot <- function(){

#
#   Mevin Hooten (20090703)
#
#   Last Updated:
#
#

####
####  Subroutines and Packages 
####

require(splancs)

####
####  Get Convex Hull 
####

dims=c(mx.sm,my.sm)
x=x.sm
y=y.sm

eps = max(min(diff(x)), min(diff(y)))
path = rbind(gps1.fall.path.list[[1]],gps1.spring.path.list[[1]])
buff.pts <- do.call('rbind',list(cbind(path[,1]+eps,path[,2]+eps),
                         cbind(path[,1]+eps,path[,2]-eps),
                         cbind(path[,1]-eps,path[,2]+eps),
                         cbind(path[,1]-eps,path[,2]-eps)))
path.hull = chull(buff.pts[, 1], buff.pts[, 2])
path.hull = c(path.hull, path.hull[1])
hullpoly = as.points(buff.pts[path.hull, 1], buff.pts[path.hull, 2])
x.lim = range(buff.pts[path.hull, 1])
y.lim = range(buff.pts[path.hull, 2])

grd.locs=expand.grid(rev(y),x)[,2:1]
in.idx=inout(as.points(grd.locs[,1],grd.locs[,2]),hullpoly,bound=TRUE)
in.mat.idx=matrix(in.idx,dims[2],dims[1])

####
####  Make Plots 
####

tmp.mat=lc.2.mat[,4]
tmp.uniq=sort(unique(tmp.mat))
ii=1
for(j in tmp.uniq){
  tmp.mat[tmp.mat==j]=ii
  ii=ii+1
}

x11()
min.y=min(diff(y.locs))
min.x=min(diff(x.locs))
image(t(matrix(tmp.mat,my,mx))[,my:1],x=x.locs,y=y.locs,xlim=c(646750,647100),ylim=c(4270800,4271000),
  xlab="",ylab="",col=gray.colors.rev(5),axes=FALSE)
lines(gps1.fall.path.list[[1]],type="l",col=1,lwd=4)
points(gps1.fall.df[,2:3],cex=2,pch=21,bg=1,col=1)
abline(v=x.locs-min.x/2)
abline(h=y.locs-min.y/2)
box()


}
