make.gps1path.plot <- function(){

#
#   Mevin Hooten (20090703)
#
#   Last Updated:
#
#

####
####  Subroutines and Packages 
####

require(splancs)
require(maps)

####
####  Get Convex Hull 
####

dims=c(mx.sm,my.sm)
x=x.sm
y=y.sm

eps = max(min(diff(x)), min(diff(y)))
path = rbind(gps1.fall.path.list[[1]],gps1.spring.path.list[[1]])
buff.pts <- do.call('rbind',list(cbind(path[,1]+eps,path[,2]+eps),
                         cbind(path[,1]+eps,path[,2]-eps),
                         cbind(path[,1]-eps,path[,2]+eps),
                         cbind(path[,1]-eps,path[,2]-eps)))
path.hull = chull(buff.pts[, 1], buff.pts[, 2])
path.hull = c(path.hull, path.hull[1])
hullpoly = as.points(buff.pts[path.hull, 1], buff.pts[path.hull, 2])
x.lim = range(buff.pts[path.hull, 1])
y.lim = range(buff.pts[path.hull, 2])

grd.locs=expand.grid(rev(y),x)[,2:1]
in.idx=inout(as.points(grd.locs[,1],grd.locs[,2]),hullpoly,bound=TRUE)
in.mat.idx=matrix(in.idx,dims[2],dims[1])

####
####  Make Plots 
####

x11()
map("state","utah",lwd=2)
map("county","utah",lwd=1,add=TRUE)

x11()
plot(hullpoly,type="l",lwd=2,axes=FALSE,ylab="",xlab="",asp=TRUE,cex.main=2)
points(gps1.fall.df[,2:3],cex=.5,pch=21,bg=1)
lines(hullpoly,lwd=2)

x11()
plot(gps1.fall.df[,2:3],type="n",xlab="",ylab="",xlim=c(645500,649000),ylim=c(4267500,4271500),asp=TRUE,axes=FALSE)
for(i in 1:length(gps1.fall.path.list)){
  lines(gps1.fall.path.list[[i]],type="l",col=8,lwd=1)
}
points(gps1.fall.df[,2:3],cex=1,pch=21,bg=1)

}
