map.post <- 
function (out, path.list, alpha.also = FALSE, cov.numb = NULL, 
    full.hull = FALSE, show.moves = FALSE, color=NULL, ...) 
{
    require(splancs)
    dims = rev(out$dims)
    x = out$x
    y = out$y
    eps = max(min(diff(x)), min(diff(y)))
    path = path.list[[1]]
    buff.pts <- do.call('rbind',list(cbind(path[,1]+eps,path[,2]+eps),
                             cbind(path[,1]+eps,path[,2]-eps),
                             cbind(path[,1]-eps,path[,2]+eps),
                             cbind(path[,1]-eps,path[,2]-eps)))
    path.hull = chull(buff.pts[, 1], buff.pts[, 2])
    path.hull = c(path.hull, path.hull[1])
    hullpoly = as.points(buff.pts[path.hull, 1], buff.pts[path.hull, 2])
    x.lim = range(buff.pts[path.hull, 1])
    y.lim = range(buff.pts[path.hull, 2])
    grd.locs = expand.grid(rev(y), x)[, 2:1]
    in.idx = inout(as.points(grd.locs[, 1], grd.locs[, 2]), hullpoly, 
        bound = TRUE)
    in.mat.idx = matrix(in.idx, dims[2], dims[1])
    if (full.hull) {
        path.2 = rbind(gps1.df[, 3:4], gps2.df[, 3:4])
        path.hull = chull(path.2[, 1], path.2[, 2])
        path.hull = c(path.hull, path.hull[1])
        hullpoly = as.points(path.2[path.hull, 1], path.2[path.hull, 
            2])
        x.lim = range(path.2[path.hull, 1])
        y.lim = range(path.2[path.hull, 2])
        grd.locs = expand.grid(rev(y), x)[, 2:1]
        in.idx = inout(as.points(grd.locs[, 1], grd.locs[, 2]), 
            hullpoly, bound = TRUE)
        in.mat.idx = matrix(in.idx, dims[2], dims[1])
    }
    alpha.post.smooth = matrix(smooth.2d(out$alpha.mean, x = cbind(as.vector(row(matrix(0, 
        dims[2], dims[1]))), as.vector(col(matrix(0, dims[2], 
        dims[1])))), ncol = dims[1], nrow = dims[2], theta = 2)$z, 
        dims[2], dims[1])
    alpha.mean = out$alpha.mean
    alpha.mean[!in.mat.idx] = NA
    alpha.post.smooth[!in.mat.idx] = NA
    A.mean = out$A.mean
    A.mean[!in.idx, ] = NA
    A.min = min(A.mean, na.rm = TRUE)
    A.max = max(A.mean, na.rm = TRUE)
    A.min.vec = apply(A.mean, 2, min, na.rm = TRUE)
    A.max.vec = apply(A.mean, 2, max, na.rm = TRUE)
    if(!is.null(color)) n.color <- length(color)
    else n.color <- 100
    A.l.vec = floor(n.color * (A.min.vec - A.min)/(A.max - A.min))
    A.u.vec = ceiling(n.color * (A.max.vec - A.min)/(A.max - A.min))
    A.l.NS.vec = A.l.vec[2:3]
    A.l.EW.vec = A.l.vec[c(1, 4)]
    A.u.NS.vec = A.u.vec[2:3]
    A.u.EW.vec = A.u.vec[c(1, 4)]
#     if (FALSE) {
#         A.min.NS = min(A.mean[, 2:3], na.rm = TRUE)
#         A.max.NS = max(A.mean[, 2:3], na.rm = TRUE)
#         A.min.NS.vec = apply(A.mean[, 2:3], 2, min, na.rm = TRUE)
#         A.max.NS.vec = apply(A.mean[, 2:3], 2, max, na.rm = TRUE)
#         A.min.EW = min(A.mean[, c(1, 4)], na.rm = TRUE)
#         A.max.EW = max(A.mean[, c(1, 4)], na.rm = TRUE)
#         A.min.EW.vec = apply(A.mean[, c(1, 4)], 2, min, na.rm = TRUE)
#         A.max.EW.vec = apply(A.mean[, c(1, 4)], 2, max, na.rm = TRUE)
#         if(!is.null(color)) n.color <- length(color)
#         else n.color <- 100
#         A.l.NS.vec = floor(n.color * (A.min.NS.vec - A.min.NS)/(A.max.NS - 
#             A.min.NS))
#         A.u.NS.vec = ceiling(n.color * (A.max.NS.vec - A.min.NS)/(A.max.NS - 
#             A.min.NS))
#         A.l.EW.vec = floor(n.color * (A.min.EW.vec - A.min.EW)/(A.max.EW - 
#             A.min.EW))
#         A.u.EW.vec = ceiling(n.color * (A.max.EW.vec - A.min.EW)/(A.max.EW - 
#             A.min.EW))
#     }
    GWR.colors <- colorRampPalette(c("red", "white", "green"))
    GWR.colors.2 <- colorRampPalette(c("red", "white", "green"))
 	if(is.null(color)) gray.cols = GWR.colors(100)
 	else gray.cols=color
    layout(matrix(c(0, 1, 0, 2, 3, 4, 0, 5, 6), 3, 3))
    image(t(matrix(A.mean[, 1], dims[2], dims[1]))[, dims[2]:1], 
        x = x, y = y, asp=TRUE, main = "West", xlab = "", ylab = "", 
        xlim = x.lim, ylim = y.lim, 
        col = gray.cols[A.l.EW.vec[1]:A.u.EW.vec[1]], ...)
    polymap(hullpoly, add = TRUE)
    points(path, pch = ".", col = 4)
    box()
    image(t(matrix(A.mean[, 2], dims[2], dims[1]))[, dims[2]:1], 
        x = x, y = y, asp = TRUE, main = "North", xlab = "", 
        ylab = "", xlim = x.lim, ylim = y.lim, col = gray.cols[A.l.NS.vec[1]:A.u.NS.vec[1]], ...)
    polymap(hullpoly, add = TRUE)
    points(path, pch = ".", col = 4)
    box()
    image(t(matrix(alpha.mean, dims[2], dims[1]))[, dims[2]:1], 
        x = x, y = y, asp = TRUE, main = "alpha", xlab = "", 
        ylab = "", xlim = x.lim, ylim = y.lim, col = color)
    polymap(hullpoly, add = TRUE)
    box()
    points(path, pch = ".", col = 4)
    image(t(matrix(A.mean[, 3], dims[2], dims[1]))[, dims[2]:1], 
        x = x, y = y, asp = TRUE, main = "South", xlab = "", 
        ylab = "", xlim = x.lim, ylim = y.lim, col = gray.cols[A.l.NS.vec[2]:A.u.NS.vec[2]])
    polymap(hullpoly, add = TRUE)
    points(path, pch = ".", col = 4)
    box()
    image(t(matrix(A.mean[, 4], dims[2], dims[1]))[, dims[2]:1], 
        x = x, y = y, asp = TRUE, main = "East", xlab = "", ylab = "", 
        xlim = x.lim, ylim = y.lim, col = gray.cols[A.l.EW.vec[2]:A.u.EW.vec[2]])
    polymap(hullpoly, add = TRUE)
    points(path, pch = ".", col = 4)
    box()
    image(t(matrix(apply(abs(A.mean), 1, sum), dims[2], dims[1]))[, 
        dims[2]:1], x = x, y = y, asp = TRUE, main = "sum(A)", 
        xlab = "", ylab = "", xlim = x.lim, ylim = y.lim, col = color)
    polymap(hullpoly, add = TRUE)
    points(path, pch = ".", col = 4)
    box()
    if (alpha.also) {
        x11()
        image(t(alpha.post.smooth)[, dims[2]:1], x = x, y = y, 
            asp = TRUE, main = "alpha", xlab = "", ylab = "", 
            xlim = x.lim, ylim = y.lim, col = gray.colors.rev(100))
        polymap(hullpoly, add = TRUE)
        box()
        points(path, pch = ".", col = 4)
    }
    if (show.moves) {
        x11()
        x.tmp = out$yit.locs
        plot(x.tmp, type = "n", asp = TRUE)
        polymap(hullpoly, add = TRUE)
        box()
        points((as.matrix(x.tmp[!out$y.NA.idx, ][out$yit[, 1] == 
            1, ])), pch = 20, col = 1, cex = 1)
        points((as.matrix(x.tmp[!out$y.NA.idx, ][out$yit[, 2] == 
            1, ])), pch = 20, col = 2, cex = 1)
        points((as.matrix(x.tmp[!out$y.NA.idx, ][out$yit[, 3] == 
            1, ])), pch = 20, col = 3, cex = 1)
        points((as.matrix(x.tmp[!out$y.NA.idx, ][out$yit[, 4] == 
            1, ])), pch = 20, col = 4, cex = 1)
    }
    if (!is.null(cov.numb)) {
        x11()
        x.tmp = out$X[, cov.numb+1]
        x.tmp[!in.idx] = NA
        image(t(matrix(x.tmp, dims[2], dims[1]))[, dims[2]:1], 
            x = x, y = y, asp = TRUE, main = paste("covariate:", 
                cov.numb), xlab = "", ylab = "", xlim = x.lim, 
            ylim = y.lim, col = color)
        polymap(hullpoly, add = TRUE)
        box()
        points(path, pch = ".", col = 4)
    }
}
