scale.grid <-  function(lc,nrow,ncol){

#
#  Mevin Hooten (20090513)
#
#  Increases grid support in each direction.
#
#
#  20090521:  Fixed problem with latitude reversal.
#  20090702:  Updated to work with new covariate data.
#

####
####  Subroutines
####

require(fields)

as.image.2 <- function(x, y, z, nrow = 64, ncol = 64, grid = NULL, add.legend = TRUE,
    add = FALSE, col = tim.colors(256), ...){
   x <- as.matrix(x)
    if (ncol(x) == 2) {
        z <- y
    }
    if (ncol(x) == 1) {
        x <- cbind(x, y)
    }
    if (ncol(x) == 3) {
        z <- x[, 3]
        x <- x[, 1:2]
    }
    out.p <- as.image(z, x = x, nrow = nrow, ncol = ncol, na.rm = TRUE)
    out.p
}

####
####  Get Design Matrix 
####

X=model.matrix(~as.factor(lc[,4]))
X=cbind(X,lc[,-(1:4)])
n.lc=dim(X)[2]

X.new=matrix(0,nrow*ncol,n.lc)

####
####  Get New Grid  
####

for(j in 1:n.lc){
  cat(j," ")
  image.tmp=as.image.2(lc[,2],lc[,3],X[,j],nrow=nrow,ncol=ncol)
  tmp.z=t(image.tmp$z[,ncol:1])
  X.new[,j]=as.vector(tmp.z)
}
cat("\n")

####
####   Write Output   
####

lc.vec=rep(0,nrow*ncol)
locs=expand.grid(rev(image.tmp$y),image.tmp$x)[,2:1]
lc.mat=cbind(1:(nrow*ncol),lc.vec,locs)

list(X=X.new,locs.idx=image.tmp$ind,locs=locs,y=image.tmp$y,x=image.tmp$x,lc.mat=lc.mat)

}
